"""
Django settings for growgetter project.

Generated by 'django-admin startproject' using Django 4.0.5.

For more information on this file, see
https://docs.djangoproject.com/en/4.0/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/4.0/ref/settings/
"""
import ast
from os import environ
from pathlib import Path

# Build paths inside the project like this: BASE_DIR / 'subdir'.
BASE_DIR = Path(__file__).resolve().parent.parent
COMIC_DIR = str(environ['GG_COMIC_DIR'])

# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/4.0/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = str(environ['GG_DJANGO_SECRET_KEY'])

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = ast.literal_eval(str(environ['GG_DJANGO_DEBUG']))

ALLOWED_HOSTS = ['127.0.0.1', str(environ['GG_DJANGO_HOSTS'])]


# Application definition

INSTALLED_APPS = [
    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',
    'rest_framework',
    'rest_framework.authtoken',
    'drf_yasg',
    'drf_standardized_errors',
    'huey.contrib.djhuey',
    'api.apps.ApiConfig',
    'watermark.apps.WatermarkConfig',
    'docs.apps.DocsConfig',
]

MIDDLEWARE = [
    'django.middleware.security.SecurityMiddleware',
    'whitenoise.middleware.WhiteNoiseMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
]

ROOT_URLCONF = 'growgetter.urls'

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': [],
        'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
            ],
        },
    },
]

WSGI_APPLICATION = 'growgetter.wsgi.application'


# Database
# https://docs.djangoproject.com/en/4.0/ref/settings/#databases

DATABASES = {
    'default': {
        'ENGINE': 'django.db.backends.postgresql',
        'NAME': environ['GG_DB_NAME'],
        'USER': environ['GG_DB_USER'],
        'PASSWORD': environ['GG_DB_PASS'],
        'HOST': '127.0.0.1',
        'PORT': '5432',
    }
}


# Password validation
# https://docs.djangoproject.com/en/4.0/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    },
]


# Internationalization
# https://docs.djangoproject.com/en/4.0/topics/i18n/

LANGUAGE_CODE = 'en-us'

TIME_ZONE = 'UTC'

USE_I18N = True

USE_TZ = True


# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/4.0/howto/static-files/

STATIC_URL = 'static/'
STATIC_ROOT = BASE_DIR / "staticfiles"
STATICFILES_STORAGE = "whitenoise.storage.CompressedStaticFilesStorage"
FONT_DIR = STATIC_ROOT / 'fonts'
WATERMARKED_DIR = Path('/var/opt/growgetter/')
WATERMARKED_DOC_PATH = WATERMARKED_DIR / 'watermarked.pdf'

# Default primary key field type
# https://docs.djangoproject.com/en/4.0/ref/settings/#default-auto-field

DEFAULT_AUTO_FIELD = 'django.db.models.BigAutoField'


HUEY = {
    'huey_class': 'huey.RedisHuey',  # Huey implementation to use.
    'name': 'growgettercomics',  # settings.DATABASES['default']['NAME'],
    'consumer': {'workers': 2, 'worker_type': 'thread'},
    'immediate': False,
}


# DigitalOcean Spaces

SPACES_KEY = environ['GG_SPACES_KEY']
SPACES_ENDPOINT_URL = 'https://' + environ['GG_SPACES_ENDPOINT_URL']
SPACES_SECRET = environ['GG_SPACES_SECRET']
SPACES_BUCKET = environ['GG_SPACES_BUCKET']
SPACES_REGION = environ['GG_SPACES_REGION']

REST_FRAMEWORK = {
    # other settings
    'EXCEPTION_HANDLER': 'drf_standardized_errors.exception_handler',
    'DEFAULT_AUTHENTICATION_CLASSES': [
        'rest_framework.authentication.TokenAuthentication',
    ],
    'DEFAULT_PERMISSION_CLASSES': [
        'rest_framework.permissions.IsAuthenticated',
    ],
}

# Mailgun

MAILGUN_APIKEY = environ['GG_MAILGUN_APIKEY']
MAILGUN_EMAIL = environ['GG_MAILGUN_EMAIL']
MAILGUN_DOMAIN = environ['GG_MAILGUN_DOMAIN']
MAILGUN_SENDER = environ['GG_MAILGUN_SENDER']
